# lisp versions and specific slime package releases
%define cmucl_ver  2005.08
%define cmucl_rel  1
%define sbcl_ver   0.9.3
%define sbcl_rel   1
%define clisp_ver  1:2.33.2
%define clisp_rel  1

%define cmucl_build 1
%define sbcl_build  1
%{!?fc4:%define clisp_build 1}
%{?fc4:%define clisp_build 0}
                                                                                
Summary:      Superior Lisp Interaction Mode for Emacs
Name:         slime
Version:      1.2.1
Release:      1
License:      GPL
Group:        Development/Languages
URL:          http://www.cliki.net/SLIME
Source0:      %{name}-%{version}.tar.gz
Patch0:       slime-1.2.1-swank-loader.patch
Patch1:       slime-1.2.1-swank-build.patch
Patch2:       slime-1.2.1-doc-makefile.patch
BuildRoot:    %{_tmppath}/%{name}-%{version}-root
Packager:     Fernando Lopez-Lezcano
Vendor: Planet CCRMA
Distribution: Planet CCRMA

%if "%{cmucl_build}" == "1"
BuildRequires: cmucl = %{cmucl_ver}
%endif
%if "%{sbcl_build}" == "1"
BuildRequires: sbcl = %{sbcl_ver}
%endif
%if "%{clisp_build}" == "1"
BuildRequires: clisp = %{clisp_ver}
%endif
BuildRequires: texinfo tetex tetex-latex tetex-dvips

%description
SLIME is the Superior Lisp Interaction Mode for Emacs. This is an
ILISP-like development environment intended for maximum integration
with CMUCL (also works with SBCL, OpenMCL and work is ongoing on
Lispworks and current CVS version of CLISP and CLISP 2.32 on Linux).

%package cmucl
Summary:   Slime binaries for CMUCL
Release:   %{cmucl_rel}
Group:     Development/Languages
Requires:  cmucl = %{cmucl_ver}
Requires:  slime = %{version}-%{release}

%description cmucl
Slime binaries for CMUCL

%package sbcl
Summary:   Slime binaries for SBCL
Release:   %{sbcl_rel}
Group:     Development/Languages
Requires:  sbcl = %{sbcl_ver}
Requires:  slime = %{version}-%{release}

%description sbcl
Slime binaries for SBCL

%package clisp
Summary:   Slime binaries for Clisp
Release:   %{clisp_rel}
Group:     Development/Languages
Requires:  clisp = %{clisp_ver}
Requires:  slime = %{version}-%{release}

%description clisp
Slime binaries for Clisp


%prep
%setup -q
%patch1 -p1
%patch2 -p1

%build
%if "%{cmucl_build}" == "1"
/usr/bin/lisp <<EOF
(in-package :cl-user)
(load "swank-loader.lisp")
(quit)
EOF
%endif

%if "%{sbcl_build}" == "1"
/usr/bin/sbcl <<EOF
(in-package :cl-user)
(load "swank-loader.lisp")
(quit)
EOF
%endif

%if "%{clisp_build}" == "1"
/usr/bin/clisp <<EOF
(in-package :cl-user)
(load "swank-loader.lisp")
(in-package :cl-user)
(bye)
EOF
%endif

# create documentation
cd doc
%{__make}
%{__make} slime.pdf

%install
%{__rm} -rf %{buildroot}
%{__mkdir} -p %{buildroot}%{_datadir}

%{__mkdir} -p %{buildroot}%{_libdir}/slime
%{__mv} fasl %{buildroot}%{_libdir}/slime

cd %{buildroot}%{_datadir}
%{__tar} xzpf %{SOURCE0}
%{__mv} slime-%{version} slime
cd slime
%{__patch} -p1 <%{PATCH0}

%clean
%{__rm} -rf %{buildroot}


%files
%defattr(-,root,root,-)
%doc HACKING NEWS PROBLEMS README
%doc doc/slime.ps doc/slime.pdf
%{_datadir}/slime

%if "%{cmucl_build}" == "1"
%files cmucl
%defattr(-,root,root,-)
%{_libdir}/slime/fasl/cmu*
%endif

%if "%{sbcl_build}" == "1"
%files sbcl
%defattr(-,root,root,-)
%{_libdir}/slime/fasl/sbcl*
%endif

%if "%{clisp_build}" == "1"
%files clisp
%defattr(-,root,root,-)
%{_libdir}/slime/fasl/clisp*
%endif

%changelog
* Tue Aug 16 2005 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 1.2.1-1
- updated to 1.2.1, updated swank patches
- do not build for clisp on fc4
- replaced texi2pdf with dvipdfm (fc4 does not include texi2pdf
* Wed Dec 29 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- spec file cleanup
* Mon Nov  8 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- added documentation build
* Sun Nov  7 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 1.0-1
- initial build.
